import { defineComponent, $prefix, setup as _setup } from "@dftvue2-opentiny/vue-common";
import { renderless, api } from "@dftvue2-opentiny/vue-renderless/area/vue";
import Select from "@dftvue2-opentiny/vue-select";
import Option from "@dftvue2-opentiny/vue-option";
function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function hook2(context) {
      context = context || // cached call
      this.$vnode && this.$vnode.ssrContext || // stateful
      this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

import "@dftvue2-opentiny/vue-theme/area/index.css";
var __vue2_script = defineComponent({
  name: $prefix + "Area",
  components: {
    TinySelect: Select,
    TinyOption: Option
  },
  props: {
    modelValue: {},
    placeholder: {
      type: String,
      default: ""
    },
    size: String,
    disabled: {
      type: Boolean,
      default: false
    },
    props: {
      type: Object,
      default: function _default() {
        return {
          label: "name_cn",
          value: "org_id"
        };
      }
    },
    fetchJcr: {
      type: Function
    },
    fetchRegion: {
      type: Function
    },
    fetchRep: {
      type: Function
    },
    fetchOffice: {
      type: Function
    },
    popperClass: String,
    popperAppendToBody: {
      type: Boolean,
      default: true
    }
  },
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      mono: true
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-area"
  }, [_c("tiny-select", _vm._b({
    ref: "refInstance",
    attrs: {
      "popper-class": "tiny-area-jcr" + (_vm.popperClass ? " " + _vm.popperClass : ""),
      "popper-append-to-body": _vm.popperAppendToBody,
      "size": _vm.size,
      "placeholder": _vm.placeholder,
      "disabled": _vm.disabled
    },
    on: {
      "change": _vm.getRegion,
      "clear": function clear($event) {
        return _vm.$emit("clear");
      },
      "visible-change": function visibleChange($event) {
        return _vm.$emit("visible-change", $event);
      }
    },
    model: {
      value: _vm.state.jcr,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "jcr", $$v);
      },
      expression: "state.jcr"
    }
  }, "tiny-select", _vm.a(_vm.$attrs, ["^on[A-Z]"]), false), _vm._l(_vm.state.jcrData, function(item) {
    return _c("tiny-option", {
      key: item[_vm.props.value],
      attrs: {
        "label": item[_vm.props.label],
        "value": item[_vm.props.value]
      }
    });
  }), 1), _c("tiny-select", _vm._b({
    attrs: {
      "popper-class": "tiny-area-region" + (_vm.popperClass ? " " + _vm.popperClass : ""),
      "popper-append-to-body": _vm.popperAppendToBody,
      "size": _vm.size,
      "placeholder": _vm.placeholder,
      "disabled": _vm.disabled
    },
    on: {
      "change": _vm.getRep,
      "clear": function clear($event) {
        return _vm.$emit("clear");
      },
      "visible-change": function visibleChange($event) {
        return _vm.$emit("visible-change", $event);
      }
    },
    model: {
      value: _vm.state.region,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "region", $$v);
      },
      expression: "state.region"
    }
  }, "tiny-select", _vm.a(_vm.$attrs, ["^on[A-Z]"]), false), _vm._l(_vm.state.regionData, function(item) {
    return _c("tiny-option", {
      key: item[_vm.props.value],
      attrs: {
        "label": item[_vm.props.label],
        "value": item[_vm.props.value]
      }
    });
  }), 1), _c("tiny-select", _vm._b({
    attrs: {
      "popper-class": "tiny-area-rep" + (_vm.popperClass ? " " + _vm.popperClass : ""),
      "popper-append-to-body": _vm.popperAppendToBody,
      "size": _vm.size,
      "placeholder": _vm.placeholder,
      "disabled": _vm.disabled
    },
    on: {
      "change": _vm.getOffice,
      "clear": function clear($event) {
        return _vm.$emit("clear");
      },
      "visible-change": function visibleChange($event) {
        return _vm.$emit("visible-change", $event);
      }
    },
    model: {
      value: _vm.state.rep,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "rep", $$v);
      },
      expression: "state.rep"
    }
  }, "tiny-select", _vm.a(_vm.$attrs, ["^on[A-Z]"]), false), _vm._l(_vm.state.repData, function(item) {
    return _c("tiny-option", {
      key: item[_vm.props.value],
      attrs: {
        "label": item[_vm.props.label],
        "value": item[_vm.props.value]
      }
    });
  }), 1), _c("tiny-select", _vm._b({
    attrs: {
      "popper-class": "tiny-area-office" + (_vm.popperClass ? " " + _vm.popperClass : ""),
      "popper-append-to-body": _vm.popperAppendToBody,
      "size": _vm.size,
      "placeholder": _vm.placeholder,
      "disabled": _vm.disabled
    },
    on: {
      "change": _vm.changeOffice,
      "clear": function clear($event) {
        return _vm.$emit("clear");
      },
      "visible-change": function visibleChange($event) {
        return _vm.$emit("visible-change", $event);
      }
    },
    model: {
      value: _vm.state.office,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "office", $$v);
      },
      expression: "state.office"
    }
  }, "tiny-select", _vm.a(_vm.$attrs, ["^on[A-Z]"]), false), _vm._l(_vm.state.officeData, function(item) {
    return _c("tiny-option", {
      key: item[_vm.props.value],
      attrs: {
        "label": item[_vm.props.label],
        "value": item[_vm.props.value]
      }
    });
  }), 1)], 1);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var Area = /* @__PURE__ */ function() {
  return __component__.exports;
}();
var version = "2.8.0";
Area.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
Area.install = function(Vue) {
  Vue.component(Area.name, Area);
};
Area.version = version;
export {
  Area as default
};
